﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Windows.Forms;
using NationalInstruments.DAQmx;

namespace TC01App
{
    public partial class Form1 : Form
    {

        private AnalogSingleChannelReader _AnalogSingleChannelReader0;
        private AnalogSingleChannelReader _AnalogSingleChannelReader1;
        private AnalogSingleChannelReader _AnalogSingleChannelReader2;
        private AnalogSingleChannelReader _AnalogSingleChannelReader3;
        private AnalogSingleChannelReader _AnalogSingleChannelReader4;
        private AnalogSingleChannelReader _AnalogSingleChannelReader5;
        private AnalogSingleChannelReader _AnalogSingleChannelReader6;
        private AnalogSingleChannelReader _AnalogSingleChannelReader7;

        public Form1()
        {
            InitializeComponent();

            Task task0 = new Task();
            AIChannel aiChannel0 = task0.AIChannels.CreateVoltageChannel("dev1/ai0", "myAIChannel", AITerminalConfiguration.Differential, 0, 5, AIVoltageUnits.Volts);
            _AnalogSingleChannelReader0 = new AnalogSingleChannelReader(task0.Stream);

            Task task1 = new Task();
            AIChannel aiChannel1 = task1.AIChannels.CreateVoltageChannel("dev1/ai1", "myAIChannel", AITerminalConfiguration.Differential, 0, 5, AIVoltageUnits.Volts);
            _AnalogSingleChannelReader1 = new AnalogSingleChannelReader(task1.Stream);

            Task task2 = new Task();
            AIChannel aiChannel2 = task2.AIChannels.CreateVoltageChannel("dev1/ai2", "myAIChannel", AITerminalConfiguration.Differential, 0, 5, AIVoltageUnits.Volts);
            _AnalogSingleChannelReader2 = new AnalogSingleChannelReader(task2.Stream);

            Task task3 = new Task();
            AIChannel aiChannel3 = task3.AIChannels.CreateVoltageChannel("dev1/ai3", "myAIChannel", AITerminalConfiguration.Differential, 0, 5, AIVoltageUnits.Volts);
            _AnalogSingleChannelReader3 = new AnalogSingleChannelReader(task3.Stream);

            Task task4 = new Task();
            AIChannel aiChannel4 = task4.AIChannels.CreateVoltageChannel("dev1/ai4", "myAIChannel", AITerminalConfiguration.Rse, 0, 5, AIVoltageUnits.Volts);
            _AnalogSingleChannelReader4 = new AnalogSingleChannelReader(task4.Stream);

            Task task5 = new Task();
            AIChannel aiChannel5 = task5.AIChannels.CreateVoltageChannel("dev1/ai5", "myAIChannel", AITerminalConfiguration.Rse, 0, 5, AIVoltageUnits.Volts);
            _AnalogSingleChannelReader5 = new AnalogSingleChannelReader(task5.Stream);

            Task task6 = new Task();
            AIChannel aiChannel6 = task6.AIChannels.CreateVoltageChannel("dev1/ai6", "myAIChannel", AITerminalConfiguration.Rse, 0, 5, AIVoltageUnits.Volts);
            _AnalogSingleChannelReader6 = new AnalogSingleChannelReader(task6.Stream);

            Task task7 = new Task();
            AIChannel aiChannel7 = task7.AIChannels.CreateVoltageChannel("dev1/ai7", "myAIChannel", AITerminalConfiguration.Rse, 0, 5, AIVoltageUnits.Volts);
            _AnalogSingleChannelReader7 = new AnalogSingleChannelReader(task7.Stream);
        }

        private void _GetData_Click(object sender, EventArgs e)
        {

            double voltage0 = _AnalogSingleChannelReader0.ReadSingleSample();
            double voltage1 = _AnalogSingleChannelReader1.ReadSingleSample();
            double voltage2 = _AnalogSingleChannelReader2.ReadSingleSample();
            double voltage3 = _AnalogSingleChannelReader3.ReadSingleSample();
            double voltage4 = _AnalogSingleChannelReader4.ReadSingleSample();
            double voltage5 = _AnalogSingleChannelReader5.ReadSingleSample();
            double voltage6 = _AnalogSingleChannelReader6.ReadSingleSample();
            double voltage7 = _AnalogSingleChannelReader7.ReadSingleSample();

            _Voltage0.Text = string.Concat(voltage0.ToString("0.0"));
            _Voltage1.Text = string.Concat(voltage1.ToString("0.0"));
            _Voltage2.Text = string.Concat(voltage2.ToString("0.0"));
            _Voltage3.Text = string.Concat(voltage3.ToString("0.0"));
            _Voltage4.Text = string.Concat(voltage4.ToString("0.0"));
            _Voltage5.Text = string.Concat(voltage5.ToString("0.0"));
            _Voltage6.Text = string.Concat(voltage6.ToString("0.0"));
            _Voltage7.Text = string.Concat(voltage7.ToString("0.0"));
        }
    }
}
